/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.eclipse.jubula.client.core.gen.parser.parameter.parser;

import org.eclipse.jubula.client.core.gen.parser.parameter.lexer.*;
import org.eclipse.jubula.client.core.gen.parser.parameter.node.*;
import org.eclipse.jubula.client.core.gen.parser.parameter.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(@SuppressWarnings("hiding") Lexer lexer)
    {
        this.lexer = lexer;
    }

    protected void filter() throws ParserException, LexerException, IOException
    {
        // Empty body
    }

    private void push(int numstate, ArrayList listNode, boolean hidden) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!hidden)
        {
            filter();
        }

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
        return ((State) this.stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

    @SuppressWarnings("unchecked")
    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, true);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(this.lexer.next());
                        push(this.action[1], list, false);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AAparameter1Parameter */
		    {
			ArrayList list = new0();
			push(goTo(0), list, false);
		    }
		    break;
                    case 1: /* reduce AAparameter2Parameter */
		    {
			ArrayList list = new1();
			push(goTo(0), list, false);
		    }
		    break;
                    case 2: /* reduce ALiteralParamToken */
		    {
			ArrayList list = new2();
			push(goTo(1), list, false);
		    }
		    break;
                    case 3: /* reduce AEscapeSequenceParamToken */
		    {
			ArrayList list = new3();
			push(goTo(1), list, false);
		    }
		    break;
                    case 4: /* reduce AReferenceParamToken */
		    {
			ArrayList list = new4();
			push(goTo(1), list, false);
		    }
		    break;
                    case 5: /* reduce AVariableParamToken */
		    {
			ArrayList list = new5();
			push(goTo(1), list, false);
		    }
		    break;
                    case 6: /* reduce AFunctionParamToken */
		    {
			ArrayList list = new6();
			push(goTo(1), list, false);
		    }
		    break;
                    case 7: /* reduce AAlphanumericParamToken */
		    {
			ArrayList list = new7();
			push(goTo(1), list, false);
		    }
		    break;
                    case 8: /* reduce AAnySequenceParamToken */
		    {
			ArrayList list = new8();
			push(goTo(1), list, false);
		    }
		    break;
                    case 9: /* reduce AAliteral1Literal */
		    {
			ArrayList list = new9();
			push(goTo(2), list, false);
		    }
		    break;
                    case 10: /* reduce AAliteral2Literal */
		    {
			ArrayList list = new10();
			push(goTo(2), list, false);
		    }
		    break;
                    case 11: /* reduce AAreference1Reference */
		    {
			ArrayList list = new11();
			push(goTo(3), list, false);
		    }
		    break;
                    case 12: /* reduce AAreference2Reference */
		    {
			ArrayList list = new12();
			push(goTo(3), list, false);
		    }
		    break;
                    case 13: /* reduce AAreference3Reference */
		    {
			ArrayList list = new13();
			push(goTo(3), list, false);
		    }
		    break;
                    case 14: /* reduce AAreference4Reference */
		    {
			ArrayList list = new14();
			push(goTo(3), list, false);
		    }
		    break;
                    case 15: /* reduce AAreference5Reference */
		    {
			ArrayList list = new15();
			push(goTo(3), list, false);
		    }
		    break;
                    case 16: /* reduce AAreference6Reference */
		    {
			ArrayList list = new16();
			push(goTo(3), list, false);
		    }
		    break;
                    case 17: /* reduce AAreference7Reference */
		    {
			ArrayList list = new17();
			push(goTo(3), list, false);
		    }
		    break;
                    case 18: /* reduce AAreference8Reference */
		    {
			ArrayList list = new18();
			push(goTo(3), list, false);
		    }
		    break;
                    case 19: /* reduce AAvariable1Variable */
		    {
			ArrayList list = new19();
			push(goTo(4), list, false);
		    }
		    break;
                    case 20: /* reduce AAvariable2Variable */
		    {
			ArrayList list = new20();
			push(goTo(4), list, false);
		    }
		    break;
                    case 21: /* reduce AAvariable3Variable */
		    {
			ArrayList list = new21();
			push(goTo(4), list, false);
		    }
		    break;
                    case 22: /* reduce AAvariable4Variable */
		    {
			ArrayList list = new22();
			push(goTo(4), list, false);
		    }
		    break;
                    case 23: /* reduce AAvariable5Variable */
		    {
			ArrayList list = new23();
			push(goTo(4), list, false);
		    }
		    break;
                    case 24: /* reduce AAvariable6Variable */
		    {
			ArrayList list = new24();
			push(goTo(4), list, false);
		    }
		    break;
                    case 25: /* reduce AAvariable7Variable */
		    {
			ArrayList list = new25();
			push(goTo(4), list, false);
		    }
		    break;
                    case 26: /* reduce AAvariable8Variable */
		    {
			ArrayList list = new26();
			push(goTo(4), list, false);
		    }
		    break;
                    case 27: /* reduce AAfunction1Function */
		    {
			ArrayList list = new27();
			push(goTo(5), list, false);
		    }
		    break;
                    case 28: /* reduce AAfunction2Function */
		    {
			ArrayList list = new28();
			push(goTo(5), list, false);
		    }
		    break;
                    case 29: /* reduce AOneFunctionArgList */
		    {
			ArrayList list = new29();
			push(goTo(6), list, false);
		    }
		    break;
                    case 30: /* reduce AManyFunctionArgList */
		    {
			ArrayList list = new30();
			push(goTo(6), list, false);
		    }
		    break;
                    case 31: /* reduce AAlphanumericFunctionArgToken */
		    {
			ArrayList list = new31();
			push(goTo(7), list, false);
		    }
		    break;
                    case 32: /* reduce ALiteralFunctionArgToken */
		    {
			ArrayList list = new32();
			push(goTo(7), list, false);
		    }
		    break;
                    case 33: /* reduce AEscapeSequenceFunctionArgToken */
		    {
			ArrayList list = new33();
			push(goTo(7), list, false);
		    }
		    break;
                    case 34: /* reduce AReferenceFunctionArgToken */
		    {
			ArrayList list = new34();
			push(goTo(7), list, false);
		    }
		    break;
                    case 35: /* reduce AVariableFunctionArgToken */
		    {
			ArrayList list = new35();
			push(goTo(7), list, false);
		    }
		    break;
                    case 36: /* reduce AFunctionFunctionArgToken */
		    {
			ArrayList list = new36();
			push(goTo(7), list, false);
		    }
		    break;
                    case 37: /* reduce AFunctionArg */
		    {
			ArrayList list = new37();
			push(goTo(8), list, false);
		    }
		    break;
                    case 38: /* reduce ATerminal$ParamToken */
		    {
			ArrayList list = new38();
			push(goTo(9), list, true);
		    }
		    break;
                    case 39: /* reduce ANonTerminal$ParamToken */
		    {
			ArrayList list = new39();
			push(goTo(9), list, true);
		    }
		    break;
                    case 40: /* reduce ATerminal$FunctionArgToken */
		    {
			ArrayList list = new40();
			push(goTo(10), list, true);
		    }
		    break;
                    case 41: /* reduce ANonTerminal$FunctionArgToken */
		    {
			ArrayList list = new41();
			push(goTo(10), list, true);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PParameter node1 = (PParameter) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " +
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



    @SuppressWarnings("unchecked")
    ArrayList new0() /* reduce AAparameter1Parameter */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PParameter pparameterNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        }

        pparameterNode1 = new AParameter(listNode2);
        }
	nodeList.add(pparameterNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new1() /* reduce AAparameter2Parameter */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParameter pparameterNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList1.get(0);
	if(listNode2 != null)
	{
	  listNode3.addAll(listNode2);
	}
        }

        pparameterNode1 = new AParameter(listNode3);
        }
	nodeList.add(pparameterNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new2() /* reduce ALiteralParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        PLiteral pliteralNode2;
        pliteralNode2 = (PLiteral)nodeArrayList1.get(0);

        pparamtokenNode1 = new ALiteralParamToken(pliteralNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new3() /* reduce AEscapeSequenceParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        TEscapedSymbol tescapedsymbolNode2;
        tescapedsymbolNode2 = (TEscapedSymbol)nodeArrayList1.get(0);

        pparamtokenNode1 = new AEscapeSequenceParamToken(tescapedsymbolNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new4() /* reduce AReferenceParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        PReference preferenceNode2;
        preferenceNode2 = (PReference)nodeArrayList1.get(0);

        pparamtokenNode1 = new AReferenceParamToken(preferenceNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new5() /* reduce AVariableParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        PVariable pvariableNode2;
        pvariableNode2 = (PVariable)nodeArrayList1.get(0);

        pparamtokenNode1 = new AVariableParamToken(pvariableNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new6() /* reduce AFunctionParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        PFunction pfunctionNode2;
        pfunctionNode2 = (PFunction)nodeArrayList1.get(0);

        pparamtokenNode1 = new AFunctionParamToken(pfunctionNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new7() /* reduce AAlphanumericParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        TAlphanumeric talphanumericNode2;
        talphanumericNode2 = (TAlphanumeric)nodeArrayList1.get(0);

        pparamtokenNode1 = new AAlphanumericParamToken(talphanumericNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new8() /* reduce AAnySequenceParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamToken pparamtokenNode1;
        {
            // Block
        TChar tcharNode2;
        tcharNode2 = (TChar)nodeArrayList1.get(0);

        pparamtokenNode1 = new AAnySequenceParamToken(tcharNode2);
        }
	nodeList.add(pparamtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new9() /* reduce AAliteral1Literal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLiteral pliteralNode1;
        {
            // Block
        TOpenLiteral topenliteralNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TCloseLiteral tcloseliteralNode4;
        topenliteralNode2 = (TOpenLiteral)nodeArrayList1.get(0);
        tcloseliteralNode4 = (TCloseLiteral)nodeArrayList2.get(0);

        pliteralNode1 = new ALiteral(topenliteralNode2, null, tcloseliteralNode4);
        }
	nodeList.add(pliteralNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new10() /* reduce AAliteral2Literal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLiteral pliteralNode1;
        {
            // Block
        TOpenLiteral topenliteralNode2;
        TLiteralBody tliteralbodyNode3;
        TCloseLiteral tcloseliteralNode4;
        topenliteralNode2 = (TOpenLiteral)nodeArrayList1.get(0);
        tliteralbodyNode3 = (TLiteralBody)nodeArrayList2.get(0);
        tcloseliteralNode4 = (TCloseLiteral)nodeArrayList3.get(0);

        pliteralNode1 = new ALiteral(topenliteralNode2, tliteralbodyNode3, tcloseliteralNode4);
        }
	nodeList.add(pliteralNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new11() /* reduce AAreference1Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        @SuppressWarnings("unused") Object nullNode4 = null;
        @SuppressWarnings("unused") Object nullNode5 = null;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, null, null, null);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new12() /* reduce AAreference2Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        TOpenBrace topenbraceNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        @SuppressWarnings("unused") Object nullNode5 = null;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, topenbraceNode3, null, null);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new13() /* reduce AAreference3Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TReferenceBody treferencebodyNode4;
        @SuppressWarnings("unused") Object nullNode5 = null;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        treferencebodyNode4 = (TReferenceBody)nodeArrayList2.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, null, treferencebodyNode4, null);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new14() /* reduce AAreference4Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        TOpenBrace topenbraceNode3;
        TReferenceBody treferencebodyNode4;
        @SuppressWarnings("unused") Object nullNode5 = null;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);
        treferencebodyNode4 = (TReferenceBody)nodeArrayList3.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, topenbraceNode3, treferencebodyNode4, null);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new15() /* reduce AAreference5Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TCloseBrace tclosebraceNode5;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList2.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, null, null, tclosebraceNode5);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new16() /* reduce AAreference6Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        TOpenBrace topenbraceNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TCloseBrace tclosebraceNode5;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList3.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, topenbraceNode3, null, tclosebraceNode5);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new17() /* reduce AAreference7Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TReferenceBody treferencebodyNode4;
        TCloseBrace tclosebraceNode5;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        treferencebodyNode4 = (TReferenceBody)nodeArrayList2.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList3.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, null, treferencebodyNode4, tclosebraceNode5);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new18() /* reduce AAreference8Reference */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReference preferenceNode1;
        {
            // Block
        TReferenceToken treferencetokenNode2;
        TOpenBrace topenbraceNode3;
        TReferenceBody treferencebodyNode4;
        TCloseBrace tclosebraceNode5;
        treferencetokenNode2 = (TReferenceToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);
        treferencebodyNode4 = (TReferenceBody)nodeArrayList3.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList4.get(0);

        preferenceNode1 = new AReference(treferencetokenNode2, topenbraceNode3, treferencebodyNode4, tclosebraceNode5);
        }
	nodeList.add(preferenceNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new19() /* reduce AAvariable1Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        @SuppressWarnings("unused") Object nullNode4 = null;
        @SuppressWarnings("unused") Object nullNode5 = null;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, null, null, null);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new20() /* reduce AAvariable2Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        TOpenBrace topenbraceNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        @SuppressWarnings("unused") Object nullNode5 = null;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, topenbraceNode3, null, null);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new21() /* reduce AAvariable3Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TVariableBody tvariablebodyNode4;
        @SuppressWarnings("unused") Object nullNode5 = null;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        tvariablebodyNode4 = (TVariableBody)nodeArrayList2.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, null, tvariablebodyNode4, null);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new22() /* reduce AAvariable4Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        TOpenBrace topenbraceNode3;
        TVariableBody tvariablebodyNode4;
        @SuppressWarnings("unused") Object nullNode5 = null;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);
        tvariablebodyNode4 = (TVariableBody)nodeArrayList3.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, topenbraceNode3, tvariablebodyNode4, null);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new23() /* reduce AAvariable5Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TCloseBrace tclosebraceNode5;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList2.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, null, null, tclosebraceNode5);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new24() /* reduce AAvariable6Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        TOpenBrace topenbraceNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TCloseBrace tclosebraceNode5;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList3.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, topenbraceNode3, null, tclosebraceNode5);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new25() /* reduce AAvariable7Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TVariableBody tvariablebodyNode4;
        TCloseBrace tclosebraceNode5;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        tvariablebodyNode4 = (TVariableBody)nodeArrayList2.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList3.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, null, tvariablebodyNode4, tclosebraceNode5);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new26() /* reduce AAvariable8Variable */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariable pvariableNode1;
        {
            // Block
        TVariableToken tvariabletokenNode2;
        TOpenBrace topenbraceNode3;
        TVariableBody tvariablebodyNode4;
        TCloseBrace tclosebraceNode5;
        tvariabletokenNode2 = (TVariableToken)nodeArrayList1.get(0);
        topenbraceNode3 = (TOpenBrace)nodeArrayList2.get(0);
        tvariablebodyNode4 = (TVariableBody)nodeArrayList3.get(0);
        tclosebraceNode5 = (TCloseBrace)nodeArrayList4.get(0);

        pvariableNode1 = new AVariable(tvariabletokenNode2, topenbraceNode3, tvariablebodyNode4, tclosebraceNode5);
        }
	nodeList.add(pvariableNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new27() /* reduce AAfunction1Function */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunction pfunctionNode1;
        {
            // Block
        TFunctionToken tfunctiontokenNode2;
        TFunctionName tfunctionnameNode3;
        TBeginFunctionArgsToken tbeginfunctionargstokenNode4;
        @SuppressWarnings("unused") Object nullNode5 = null;
        TEndFunctionArgsToken tendfunctionargstokenNode6;
        tfunctiontokenNode2 = (TFunctionToken)nodeArrayList1.get(0);
        tfunctionnameNode3 = (TFunctionName)nodeArrayList2.get(0);
        tbeginfunctionargstokenNode4 = (TBeginFunctionArgsToken)nodeArrayList3.get(0);
        tendfunctionargstokenNode6 = (TEndFunctionArgsToken)nodeArrayList4.get(0);

        pfunctionNode1 = new AFunction(tfunctiontokenNode2, tfunctionnameNode3, tbeginfunctionargstokenNode4, null, tendfunctionargstokenNode6);
        }
	nodeList.add(pfunctionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new28() /* reduce AAfunction2Function */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunction pfunctionNode1;
        {
            // Block
        TFunctionToken tfunctiontokenNode2;
        TFunctionName tfunctionnameNode3;
        TBeginFunctionArgsToken tbeginfunctionargstokenNode4;
        PFunctionArgList pfunctionarglistNode5;
        TEndFunctionArgsToken tendfunctionargstokenNode6;
        tfunctiontokenNode2 = (TFunctionToken)nodeArrayList1.get(0);
        tfunctionnameNode3 = (TFunctionName)nodeArrayList2.get(0);
        tbeginfunctionargstokenNode4 = (TBeginFunctionArgsToken)nodeArrayList3.get(0);
        pfunctionarglistNode5 = (PFunctionArgList)nodeArrayList4.get(0);
        tendfunctionargstokenNode6 = (TEndFunctionArgsToken)nodeArrayList5.get(0);

        pfunctionNode1 = new AFunction(tfunctiontokenNode2, tfunctionnameNode3, tbeginfunctionargstokenNode4, pfunctionarglistNode5, tendfunctionargstokenNode6);
        }
	nodeList.add(pfunctionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new29() /* reduce AOneFunctionArgList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgList pfunctionarglistNode1;
        {
            // Block
        PFunctionArg pfunctionargNode2;
        pfunctionargNode2 = (PFunctionArg)nodeArrayList1.get(0);

        pfunctionarglistNode1 = new AOneFunctionArgList(pfunctionargNode2);
        }
	nodeList.add(pfunctionarglistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new30() /* reduce AManyFunctionArgList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgList pfunctionarglistNode1;
        {
            // Block
        PFunctionArgList pfunctionarglistNode2;
        TComma tcommaNode3;
        PFunctionArg pfunctionargNode4;
        pfunctionarglistNode2 = (PFunctionArgList)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pfunctionargNode4 = (PFunctionArg)nodeArrayList3.get(0);

        pfunctionarglistNode1 = new AManyFunctionArgList(pfunctionarglistNode2, tcommaNode3, pfunctionargNode4);
        }
	nodeList.add(pfunctionarglistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new31() /* reduce AAlphanumericFunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgToken pfunctionargtokenNode1;
        {
            // Block
        TFunctionAlphanumeric tfunctionalphanumericNode2;
        tfunctionalphanumericNode2 = (TFunctionAlphanumeric)nodeArrayList1.get(0);

        pfunctionargtokenNode1 = new AAlphanumericFunctionArgToken(tfunctionalphanumericNode2);
        }
	nodeList.add(pfunctionargtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new32() /* reduce ALiteralFunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgToken pfunctionargtokenNode1;
        {
            // Block
        PLiteral pliteralNode2;
        pliteralNode2 = (PLiteral)nodeArrayList1.get(0);

        pfunctionargtokenNode1 = new ALiteralFunctionArgToken(pliteralNode2);
        }
	nodeList.add(pfunctionargtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new33() /* reduce AEscapeSequenceFunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgToken pfunctionargtokenNode1;
        {
            // Block
        TEscapedSymbolInFunction tescapedsymbolinfunctionNode2;
        tescapedsymbolinfunctionNode2 = (TEscapedSymbolInFunction)nodeArrayList1.get(0);

        pfunctionargtokenNode1 = new AEscapeSequenceFunctionArgToken(tescapedsymbolinfunctionNode2);
        }
	nodeList.add(pfunctionargtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new34() /* reduce AReferenceFunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgToken pfunctionargtokenNode1;
        {
            // Block
        PReference preferenceNode2;
        preferenceNode2 = (PReference)nodeArrayList1.get(0);

        pfunctionargtokenNode1 = new AReferenceFunctionArgToken(preferenceNode2);
        }
	nodeList.add(pfunctionargtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new35() /* reduce AVariableFunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgToken pfunctionargtokenNode1;
        {
            // Block
        PVariable pvariableNode2;
        pvariableNode2 = (PVariable)nodeArrayList1.get(0);

        pfunctionargtokenNode1 = new AVariableFunctionArgToken(pvariableNode2);
        }
	nodeList.add(pfunctionargtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new36() /* reduce AFunctionFunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArgToken pfunctionargtokenNode1;
        {
            // Block
        PFunction pfunctionNode2;
        pfunctionNode2 = (PFunction)nodeArrayList1.get(0);

        pfunctionargtokenNode1 = new AFunctionFunctionArgToken(pfunctionNode2);
        }
	nodeList.add(pfunctionargtokenNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new37() /* reduce AFunctionArg */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionArg pfunctionargNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList1.get(0);
	if(listNode2 != null)
	{
	  listNode3.addAll(listNode2);
	}
        }

        pfunctionargNode1 = new AFunctionArg(listNode3);
        }
	nodeList.add(pfunctionargNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new38() /* reduce ATerminal$ParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PParamToken pparamtokenNode1;
        pparamtokenNode1 = (PParamToken)nodeArrayList1.get(0);
	if(pparamtokenNode1 != null)
	{
	  listNode2.add(pparamtokenNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new39() /* reduce ANonTerminal$ParamToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PParamToken pparamtokenNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pparamtokenNode2 = (PParamToken)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pparamtokenNode2 != null)
	{
	  listNode3.add(pparamtokenNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new40() /* reduce ATerminal$FunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PFunctionArgToken pfunctionargtokenNode1;
        pfunctionargtokenNode1 = (PFunctionArgToken)nodeArrayList1.get(0);
	if(pfunctionargtokenNode1 != null)
	{
	  listNode2.add(pfunctionargtokenNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new41() /* reduce ANonTerminal$FunctionArgToken */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PFunctionArgToken pfunctionargtokenNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pfunctionargtokenNode2 = (PFunctionArgToken)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pfunctionargtokenNode2 != null)
	{
	  listNode3.add(pfunctionargtokenNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 0}, {0, SHIFT, 1}, {1, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {13, SHIFT, 6}, {16, SHIFT, 7}, },
			{{-1, ERROR, 1}, {17, SHIFT, 15}, {18, SHIFT, 16}, },
			{{-1, ERROR, 2}, {2, SHIFT, 17}, },
			{{-1, REDUCE, 11}, {10, SHIFT, 18}, {11, SHIFT, 19}, {15, SHIFT, 20}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 19}, {10, SHIFT, 21}, {11, SHIFT, 22}, {14, SHIFT, 23}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 8}, {19, ACCEPT, -1}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 4}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {1, SHIFT, 2}, {8, SHIFT, 3}, {9, SHIFT, 4}, {12, SHIFT, 5}, {13, SHIFT, 6}, {16, SHIFT, 7}, },
			{{-1, ERROR, 15}, {18, SHIFT, 25}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 17}, {3, SHIFT, 26}, },
			{{-1, REDUCE, 12}, {11, SHIFT, 27}, {15, SHIFT, 28}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 13}, {11, SHIFT, 29}, },
			{{-1, REDUCE, 20}, {11, SHIFT, 30}, {14, SHIFT, 31}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 21}, {11, SHIFT, 32}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 10}, },
			{{-1, ERROR, 26}, {0, SHIFT, 1}, {1, SHIFT, 2}, {5, SHIFT, 33}, {6, SHIFT, 34}, {7, SHIFT, 35}, {8, SHIFT, 3}, {12, SHIFT, 5}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 14}, {11, SHIFT, 44}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 24}, },
			{{-1, REDUCE, 22}, {11, SHIFT, 45}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 33}, },
			{{-1, REDUCE, 31}, },
			{{-1, REDUCE, 27}, },
			{{-1, REDUCE, 32}, },
			{{-1, REDUCE, 34}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 40}, {4, SHIFT, 46}, {7, SHIFT, 47}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 37}, {0, SHIFT, 1}, {1, SHIFT, 2}, {5, SHIFT, 33}, {6, SHIFT, 34}, {8, SHIFT, 3}, {12, SHIFT, 5}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 46}, {0, SHIFT, 1}, {1, SHIFT, 2}, {5, SHIFT, 33}, {6, SHIFT, 34}, {8, SHIFT, 3}, {12, SHIFT, 5}, },
			{{-1, REDUCE, 28}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 30}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 8}, },
			{{-1, 9}, {14, 24}, },
			{{-1, 36}, {0, 10}, {14, 10}, },
			{{-1, 37}, {0, 11}, {14, 11}, },
			{{-1, 38}, {0, 12}, {14, 12}, },
			{{-1, 39}, {0, 13}, {14, 13}, },
			{{-1, 40}, },
			{{-1, 41}, {43, 48}, },
			{{-1, 42}, {46, 49}, },
			{{-1, 14}, },
			{{-1, 43}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: ''', '?', '=', escaped symbol, '$', alphanumeric, char, EOF",
			"expecting: literal body, '''",
			"expecting: function name",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', escaped symbol, '{', '}', '$', alphanumeric, reference body, char, EOF",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', escaped symbol, '{', '}', '$', alphanumeric, variable body, char, EOF",
			"expecting: EOF",
			"expecting: '''",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', escaped symbol, '$', alphanumeric, char, EOF",
			"expecting: '('",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', escaped symbol, '}', '$', alphanumeric, reference body, char, EOF",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', escaped symbol, '}', '$', alphanumeric, char, EOF",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', escaped symbol, '}', '$', alphanumeric, variable body, char, EOF",
			"expecting: ''', '?', escaped symbol in function, function alphanumeric, ')', '=', '$'",
			"expecting: ''', '?', comma, escaped symbol in function, function alphanumeric, ')', '=', '$'",
			"expecting: comma, ')'",
			"expecting: ''', '?', escaped symbol in function, function alphanumeric, '=', '$'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 0, 4, 0, 0, 5, 0, 0, 0, 0, 0, 0, 6, 7, 8, 9, 7, 10, 11, 7, 10, 0, 7, 12, 7, 10, 7, 7, 10, 7, 13, 13, 7, 13, 13, 13, 13, 14, 13, 14, 13, 7, 7, 15, 7, 13, 14, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
